#include "GWt_globalParameters.h"
#include <Wt/WVBoxLayout>
#include <Wt/WGroupBox>
#include <Wt/WText>
#include <Wt/WLineEdit>
#include <Wt/WBreak>
#include <Wt/WPushButton>

#include <Wt/WComboBox>

#include "mixedTools.h"
#include "GWt_console.h"


GWt_globalParameters::GWt_globalParameters(PspaApplication* ps)
{
    
    pspa_ = ps;
    WVBoxLayout* globLayout = new WVBoxLayout();
    //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
    WContainerWidget *result = new WContainerWidget();
    WPanel *panel = new WPanel(result);
    panel->setTitle(" global parameters ");
    
    
    WText* freqText = new WText("frequency (MHz) : ");
    frequencyEdit_ = new WLineEdit();
    
    WText *stepText = new WText("step in phase (deg.) : ");
    stepEdit_ = new WLineEdit();
    
    WText *nstepMaxText = new WText("max step number : ");
    nstepMAxEdit_ = new WLineEdit();
    
    WText *nscText = new WText("periodicity of s.c. computation : ");
    nscEdit_ = new WLineEdit();
    
    
    
    WContainerWidget* contenu = new WContainerWidget();
    contenu->addWidget(freqText);
    contenu->addWidget(frequencyEdit_);
    contenu->addWidget(new WBreak());
    contenu->addWidget(stepText);
    contenu->addWidget(stepEdit_);
    contenu->addWidget(new WBreak());
    contenu->addWidget(nstepMaxText);
    contenu->addWidget(nstepMAxEdit_);
    contenu->addWidget(new WBreak());
    contenu->addWidget(nscText);
    contenu->addWidget(nscEdit_);
    
    
    
    panel->setCentralWidget(contenu);
    // panel->setCollapsible(true);
    
    
    //  WPanel *panelModules = new WPanel(result);
    // panelModules->setTitle(" sections of beam Line for executing softwres ");
    
    
    // WPushButton* push_add = new WPushButton("add");
    
    
    // contenuSections_ = new WContainerWidget();
    
    // addSection();
    // contenuSections_->addWidget( push_add);
    
    
    // panelModules->setCentralWidget(contenuSections_);
    
    
    globLayout->addWidget(result);
    
    setLayout(globLayout);
    renew();
}

// void GWt_globalParameters::addSection()
// {
//   unsigned k;
//   //   WComboBox* selectionBox = new WComboBox();

//     sectionSelection_.push_back(new WComboBox());

//     contenuSections_->addWidget(new WBreak());

//     contenuSections_->addWidget(new WText(" from : "));
//     contenuSections_->addWidget(new WLineEdit());
//     contenuSections_->addWidget(new WText(" to : "));
//     contenuSections_->addWidget(new WLineEdit());


//     contenuSections_->addWidget(sectionSelection_.back());

//     unsigned nb = nomDeLogiciel::getNumberOfSoftwares();
//     for ( k=0; k < nb; k++) sectionSelection_.back()->addItem( nomDeLogiciel(k).getString() );
//     //    selectionBox->addItem("Transport");
// }


void GWt_globalParameters::renew()
{
    string* param = pspa_->getDataManager()->getGlobalParameters()->getParametersString();
    if ( param == NULL )
    {
        if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
            GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
            console->addConsoleMessage(" GWt_globalParameters : empty parameter set");
        }
    }
    int nbparam = atoi(param[0].c_str());
    if ( nbparam != 4 )
    {
        if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
            GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
            console->addConsoleMessage(" GWt_globalParameters : wrong number of parameters");
        }
    }
    frequencyEdit_->setText(param[1].c_str());
    stepEdit_->setText(param[2].c_str());
    nstepMAxEdit_->setText(param[3].c_str());
    nscEdit_->setText(param[4].c_str());
}

void GWt_globalParameters::updateGlobals()
{
    string envoi[5];
    envoi[0] = string("4");
    envoi[1] = frequencyEdit_->text().toUTF8();
    envoi[2] = stepEdit_->text().toUTF8();
    envoi[3] = nstepMAxEdit_->text().toUTF8();
    envoi[4] = nscEdit_->text().toUTF8();
    pspa_->getDataManager()->getGlobalParameters()->setParametersString(envoi);
}

// void GWt_globalParameters::getExecute(unsigned index, unsigned& first, unsigned& last, int& programm)
// {
//   string debut;
//   string fin;
//   if ( index == 1)
//     {
//       debut = origineEdit1_->text().toUTF8();
//       fin = extremiteEdit1_->text().toUTF8();
//       programm = selectionBox1_->currentIndex();
//       cout << " current index " << programm << endl;
//     }
//   else
//     {
//       debut = origineEdit2_->text().toUTF8();
//       fin = extremiteEdit2_->text().toUTF8();
//     }
//   first = atoi ( debut.c_str() );
//   last = atoi ( fin.c_str() );
//   programm++;

// }

// void GWt_globalParameters::addElem()
// {
//     int dernier = pspa_->getDataManager()->beamLineSize();
//     extremiteEdit1_->setText( mixedTools::intToString(dernier) );
// }


